// Copyright (c) 2000,2001,2002  Utrecht University (The Netherlands),
// ETH Zurich (Switzerland), Freie Universitaet Berlin (Germany),
// INRIA Sophia-Antipolis (France), Martin-Luther-University Halle-Wittenberg
// (Germany), Max-Planck-Institute Saarbruecken (Germany), RISC Linz (Austria),
// and Tel-Aviv University (Israel).  All rights reserved.
//
// This file is part of CGAL (www.cgal.org); you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with CGAL.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Source: /CVSROOT/CGAL/Packages/Kernel_23/include/CGAL/Kernel/interface_macros.h,v $
// $Revision: 1.18 $ $Date: 2003/10/21 12:18:33 $
// $Name: CGAL_3_0_1  $
//
// Author(s)     : Herve Bronnimann, Sylvain Pion, Susan Hert

// This file is intentionally not protected against re-inclusion.
// It's aimed at being included from within a kernel traits class, this
// way we share more code.

// It is the responsability of the including file to correctly set the 2
// macros CGAL_Kernel_pred and CGAL_Kernel_cons.
// And they are #undefed at the end of this file.
// ==============================================================================
// T2 is an extension of CGAL (www.cgal.org) to the Oriented Projective Plane T2.
// --
// This file is based on and contains modifications to the $Source file
// mentioned above. These modifications are
//      Copyright (c) 2005 Alessandra G. Oliveira & Pedro J. de Rezende.
//      All rights reserved.
//
// The Licensing terms of the $Source file remain in force for this file.
//
// The original header from the $Source file, together with copyright, licensing
// and authoring information, is preserved above.
// --
// T2 System Concept and Design: Alessandra G. Oliveira & Pedro J. de Rezende
// Architecture and Implementation: Alessandra G. Oliveira
//
// The current version of T2 contained in this distribution is: 1.20050628
// which has been tested under and is compatible with CGAL 3.0.1
//
// Source code and other information can be found at:
// http://www.ic.unicamp.br/~rezende/T2inCGALandT2Viewer.htm


CGAL_Kernel_pred(Less_rotate_ccw_T2,
		 less_rotate_ccw_T2_object)
CGAL_Kernel_pred(Equal_T2,
		 equal_T2_object)
CGAL_Kernel_pred(Smaller_xy_one_range_infinity_T2,
		 smaller_xy_one_range_infinity_T2_object)	
CGAL_Kernel_pred(Smaller_one_range_infinity_T1,
		 smaller_one_range_infinity_T1_object)	
CGAL_Kernel_pred(Smaller_yx_one_range_infinity_T2,
		 smaller_yx_one_range_infinity_T2_object)	
CGAL_Kernel_pred(Smaller_y_one_range_infinity_T2,
		 smaller_y_one_range_infinity_T2_object)	
CGAL_Kernel_pred(Orientation_T2,
		 orientation_T2_object)	
CGAL_Kernel_pred(Collinear_are_ordered_along_line_T2,
		 collinear_are_ordered_along_line_T2_object)	
CGAL_Kernel_pred(Less_xy_T2,
		 less_xy_T2_object)	
CGAL_Kernel_pred(Left_turn_T2,
		 left_turn_T2_object)	
CGAL_Kernel_pred(Smaller_relative_distance_to_omega_T2,
		smaller_relative_distance_to_omega_T2_object)	
CGAL_Kernel_pred(Smaller_x_one_range_infinity_T2,
		smaller_x_one_range_infinity_T2_object)
CGAL_Kernel_pred(Smaller_equal_x_one_range_infinity_T2,
		smaller_equal_x_one_range_infinity_T2_object)
CGAL_Kernel_pred(Greater_x_one_range_infinity_T2,
		greater_x_one_range_infinity_T2_object)
CGAL_Kernel_pred(Greater_y_one_range_infinity_T2,
		greater_y_one_range_infinity_T2_object)
CGAL_Kernel_pred(Back_range_T2,
		back_range_T2_object)
CGAL_Kernel_pred(Less_signed_distance_to_line_T2,
		less_signed_distance_to_line_T2_object)
CGAL_Kernel_pred(Front_range_T2,
		front_range_T2_object)
CGAL_Kernel_pred(Y_equal_T2,
		y_equal_T2_object)
CGAL_Kernel_pred(X_equal_T2,
		x_equal_T2_object)
CGAL_Kernel_pred(Positive_side_line_T2,
		positive_side_line_T2_object)
CGAL_Kernel_pred(Negative_side_line_T2,
		negative_side_line_T2_object)
CGAL_Kernel_pred(Intersect_segments_T2,
		intersect_segments_T2_object)
CGAL_Kernel_cons(Antipode_T2,
		antipode_T2_object)
CGAL_Kernel_cons(Antipode_T1,
		antipode_T1_object)
CGAL_Kernel_cons(Project_to_the_other_range_T2,
		project_to_the_other_range_T2_object)
CGAL_Kernel_cons(Compute_greater_y_one_range_infinity_T2,
		compute_greater_y_one_range_infinity_T2_object)
CGAL_Kernel_cons(Compute_greater_x_one_range_infinity_T2,
		compute_greater_x_one_range_infinity_T2_object)
CGAL_Kernel_cons(Compute_smaller_x_one_range_infinity_T2,
		compute_smaller_x_one_range_infinity_T2_object)
CGAL_Kernel_cons(Compute_smaller_y_one_range_infinity_T2,
		compute_smaller_y_one_range_infinity_T2_object)
CGAL_Kernel_pred(Coincident_T2,
		coincident_T2_object)
CGAL_Kernel_pred(Not_at_infinity_T2,
		not_at_infinity_T2_object)
CGAL_Kernel_pred(Has_on_segment_T2,
		has_on_segment_T2_object)
CGAL_Kernel_pred(Point_on_segment_T2,
		point_on_segment_T2_object)
CGAL_Kernel_cons(Point_smaller_relative_distance_to_omega_T2,
		point_smaller_relative_distance_to_omega_T2_object)
CGAL_Kernel_pred(Back_range_or_minus_infinite_x_T2,
		back_range_or_minus_infinite_x_T2_object)
CGAL_Kernel_pred(Collinear_has_on_T2,
		collinear_has_on_T2_object)
CGAL_Kernel_pred(At_infinity_T2,
		at_infinity_T2_object)
CGAL_Kernel_cons(Squared_distance_T2,
		squared_distance_T2_object)
CGAL_Kernel_pred(Ccw_around_point_or_collinear_and_closer_T2,
ccw_around_point_or_collinear_and_closer_T2_object)
CGAL_Kernel_pred(Compare_x_T2,compare_x_T2_object)
CGAL_Kernel_pred(Compare_y_T2,compare_y_T2_object)
CGAL_Kernel_pred(Collinear_between_T2,collinear_between_T2_object)
CGAL_Kernel_cons(Construct_segment_T2,construct_segment_T2_object)
CGAL_Kernel_cons(Intersect_T2,intersect_T2_object)
CGAL_Kernel_cons(Construct_vertex_T2,construct_vertex_T2_object)
CGAL_Kernel_pred(Compare_distance_to_point_T2,
compare_distance_to_point_T2_object)
CGAL_Kernel_pred(Compare_around_origin_T2,
compare_around_origin_T2_object)
CGAL_Kernel_pred(Collinear_has_on_segment_T2,
collinear_has_on_segment_T2_object);
CGAL_Kernel_cons(Origin_T2,
origin_T2_object);
CGAL_Kernel_pred(Cmp_dist_collinear_origin_T2,
cmp_dist_collinear_origin_T2_object);
CGAL_Kernel_pred(Compare_T1p,
compare_T1p_object);
CGAL_Kernel_pred(Collinear_T2,
collinear_T2_object);
CGAL_Kernel_cons(Construct_opposite_segment_T2,
construct_opposite_segment_T2_object);
CGAL_Kernel_cons(Construct_circumcenter_T2,
construct_circumcenter_T2_object);
CGAL_Kernel_cons(Construct_squared_radius_T2,
construct_squared_radius_T2_object);
CGAL_Kernel_pred(Equal_relative_distance_to_omega_T2,
equal_relative_distance_to_omega_T2_object);
CGAL_Kernel_cons(Construct_direction_T2,
construct_direction_T2_object);
CGAL_Kernel_cons(Construct_line_T2,
construct_line_T2_object);
CGAL_Kernel_cons(Construct_vector_T2,
construct_vector_T2_object);
CGAL_Kernel_cons(Construct_perpendicular_direction_T2,
construct_perpendicular_direction_T2_object);
CGAL_Kernel_pred(Compare_angle_with_x_axis_T2,
compare_angle_with_x_axis_T2_object);
CGAL_Kernel_pred(Equal_x_T2, equal_x_T2_object);
CGAL_Kernel_pred(Equal_y_T2, equal_y_T2_object);
CGAL_Kernel_pred(Smaller_T1, smaller_T1_object);
CGAL_Kernel_pred(Equal_T1, equal_T1_object);

//#undef						


