// Copyright (c) 1999  Max-Planck-Institute Saarbruecken (Germany).
// All rights reserved.
//
// This file is part of CGAL (www.cgal.org); you may redistribute it under
// the terms of the Q Public License version 1.0.
// See the file LICENSE.QPL distributed with CGAL.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Source: /CVSROOT/CGAL/Packages/Convex_hull_2/include/CGAL/convex_hull_traits_2.h,v $
// $Revision: 1.12 $ $Date: 2003/10/21 12:15:06 $
// $Name: CGAL_3_0_1  $
//
// Author(s)     : Stefan Schirra

// This file's name must begin with a lower-case letter for backward 
// compatability.  Unfortunately, you can't have a file that differs only 
// in capitalization on the Windows platforms.
// ==============================================================================
// T2 is an extension of CGAL (www.cgal.org) to the Oriented Projective Plane T2.
// --
// This file is based on and contains modifications to the $Source file
// mentioned above. These modifications are
//      Copyright (c) 2005 Alessandra G. Oliveira & Pedro J. de Rezende.
//      All rights reserved.
//
// The Licensing terms of the $Source file remain in force for this file.
//
// The original header from the $Source file, together with copyright, licensing
// and authoring information, is preserved above.
// --
// T2 System Concept and Design: Alessandra G. Oliveira & Pedro J. de Rezende
// Architecture and Implementation: Alessandra G. Oliveira
//
// The current version of T2 contained in this distribution is: 1.20050628
// which has been tested under and is compatible with CGAL 3.0.1
//
// Source code and other information can be found at:
// http://www.ic.unicamp.br/~rezende/T2inCGALandT2Viewer.htm


#ifndef CGAL_CONVEX_HULL_TRAITS_T2_H
#define CGAL_CONVEX_HULL_TRAITS_T2_H

#include <CGAL/Point_T2.h>
#include <CGAL/predicates_on_points_T2.h>
#include <CGAL/distance_predicates_T2.h>

CGAL_BEGIN_NAMESPACE

template <class K_>
class Convex_hull_traits_T2 : public K_
{
public:
  typedef K_                               K;
  typedef typename K::Point_T2             Point_T2;    
  typedef typename K::Smaller_xy_one_range_infinity_T2
														 Smaller_xy_one_range_infinity_T2;             

  typedef typename K::Less_rotate_ccw_T2   Less_rotate_ccw_T2;
  typedef typename K::Equal_T2              Equal_T2;


  Smaller_xy_one_range_infinity_T2
  smaller_xy_one_range_infinity_T2_object() const 
  { return Smaller_xy_one_range_infinity_T2(); } 

  Less_rotate_ccw_T2
  less_rotate_ccw_T2_object() const 
  { return Less_rotate_ccw_T2(); } 

  Equal_T2
  equal_T2_object() const 
  { return Equal_T2(); } 	

 };


template <class K>
class convex_hull_traits_T2 : public Convex_hull_traits_T2<K>
{
};

#endif //CGAL_CONVEX_HULL_TRAITS_T2_H
