//  T2 is an extension of CGAL (www.cgal.org) to the Oriented Projective Plane T2.
//  Copyright (c) 2005 Alessandra G. Oliveira & Pedro J. de Rezende.
//  All rights reserved.
//  --
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
//  --
//  T2 System Concept and Design: Alessandra G. Oliveira & Pedro J. de Rezende
//  Architecture and Implementation: Alessandra G. Oliveira
//
//  The current version of T2 contained in this distribution is: 1.20050628
//  which has been tested under and is compatible with CGAL 3.0.1
//
//  Source code and other informations can be found at:
//  http://www.ic.unicamp.br/~rezende/T2inCGALandT2Viewer.htm


#ifndef CGAL_POLYGON_OPERATIONS_T2_H
#define CGAL_POLYGON_OPERATIONS_T2_H

CGAL_BEGIN_NAMESPACE

template < class ForwardIterator, class Point, class Traits >
inline
Oriented_side
oriented_side_polygon_T2(ForwardIterator first, ForwardIterator last, 
                         const Point &p, const Traits &traits);


template < class ForwardIterator, class Point>
inline
Oriented_side
oriented_side_polygon_T2(ForwardIterator first, ForwardIterator last, const Point &p)
{
  typedef CGAL::Kernel_traits<Point>  KTraits;
  typedef typename KTraits::Kernel    Kernel;
  return oriented_side_polygon_T2(first,last,p,Kernel());

}

CGAL_END_NAMESPACE

#ifdef CGAL_CFG_NO_AUTOMATIC_TEMPLATE_INCLUSION
#include <CGAL/polygon_operations_T2.C>
#endif // CGAL_CFG_NO_AUTOMATIC_TEMPLATE_INCLUSION

#endif //CGAL_POLYGON_OPERATIONS_T2_H
