// Copyright (c) 2000  Utrecht University (The Netherlands),
// ETH Zurich (Switzerland), Freie Universitaet Berlin (Germany),
// INRIA Sophia-Antipolis (France), Martin-Luther-University Halle-Wittenberg
// (Germany), Max-Planck-Institute Saarbruecken (Germany), RISC Linz (Austria),
// and Tel-Aviv University (Israel).  All rights reserved.
//
// This file is part of CGAL (www.cgal.org); you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; version 2.1 of the License.
// See the file LICENSE.LGPL distributed with CGAL.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $Source: /CVSROOT/CGAL/Packages/Cartesian_kernel/include/CGAL/predicates/kernel_ftC2.h,v $
// $Revision: 1.12 $ $Date: 2003/10/21 12:14:38 $
// $Name: CGAL_3_0_1  $
//
// Author(s)     : Herve Bronnimann (Herve.Bronnimann@sophia.inria.fr)
// ==============================================================================
// T2 is an extension of CGAL (www.cgal.org) to the Oriented Projective Plane T2.
// --
// This file is based on and contains modifications to the $Source file
// mentioned above. These modifications are
//      Copyright (c) 2005 Alessandra G. Oliveira & Pedro J. de Rezende.
//      All rights reserved.
//
// The Licensing terms of the $Source file remain in force for this file.
//
// The original header from the $Source file, together with copyright, licensing
// and authoring information, is preserved above.
// --
// T2 System Concept and Design: Alessandra G. Oliveira & Pedro J. de Rezende
// Architecture and Implementation: Alessandra G. Oliveira
//
// The current version of T2 contained in this distribution is: 1.20050628
// which has been tested under and is compatible with CGAL 3.0.1
//
// Source code and other information can be found at:
// http://www.ic.unicamp.br/~rezende/T2inCGALandT2Viewer.htm


#ifndef CGAL_PREDICATES_T2_CONSTRUCTIONS_KERNEL_T1T2_H
#define CGAL_PREDICATES_T2_CONSTRUCTIONS_KERNEL_T1T2_H


CGAL_BEGIN_NAMESPACE


template < class R >
inline
Comparison_result
cmp_signed_dist_to_lineT2(const typename R::FT &lw,
                          const typename R::FT &lx,
                          const typename R::FT &ly,
                          const Point_T2<R> &p,
                          const Point_T2<R> &q)
{
  return compare_front_range_infinity_T1(
										scaled_distance_to_lineT2(lw,lx,ly,p),
                    scaled_distance_to_lineT2(lw,lx,ly,q));
}

CGAL_END_NAMESPACE

#endif
